'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

require('./form.scss');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactChildrenUtilities = require('react-children-utilities');

var _reactChildrenUtilities2 = _interopRequireDefault(_reactChildrenUtilities);

var _field = require('./field.js');

var _field2 = _interopRequireDefault(_field);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* eslint-disable react/no-set-state */


/**
 * Form
 * Wraps fields in order to make a form with a submit
 */
var Form = function (_Component) {
  _inherits(Form, _Component);

  /**
   * Constructor
   * @param {Object} props - React props
   */
  function Form(props) {
    _classCallCheck(this, Form);

    var _this = _possibleConstructorReturn(this, (Form.__proto__ || Object.getPrototypeOf(Form)).call(this, props));

    _this.state = { values: {} };
    _this.handleFieldChange = _this.handleFieldChange.bind(_this);
    _this.handleSubmit = _this.handleSubmit.bind(_this);
    _this.handleReset = _this.handleReset.bind(_this);
    return _this;
  }

  /**
   * Update state from onChange fields event
   * @param     {string} fieldName - Name from a Field included in Form
   * @returns {function}           - Change event handler
   */


  _createClass(Form, [{
    key: 'handleFieldChange',
    value: function handleFieldChange(fieldName) {
      var _this2 = this;

      return function (event) {
        var values = _this2.state.values;
        values[fieldName] = event.target && event.target.value ? event.target.value : event;
        _this2.setState({ values: values });
      };
    }

    /**
     * Handle Form submit
     * @param {object} event - DOM event object
     */

  }, {
    key: 'handleReset',
    value: function handleReset(event) {
      this.setState({ values: {} });
      this.props.onReset && this.props.onReset(event);
    }

    /**
     * Handle Form submit
     * @param {object} event - DOM event object
     */

  }, {
    key: 'handleSubmit',
    value: function handleSubmit(event) {
      event.preventDefault();
      this.props.onSubmit && this.props.onSubmit(this.state.values);
    }

    /**
     * Render method
     * @returns {JSX} - Component template
     */

  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var children = this.props.children,
          formChildren = _reactChildrenUtilities2.default.deepMap(children, function (child) {
        if (child.type === _field2.default) {
          return (0, _react.cloneElement)(child, _extends({}, child.props, {
            onChange: _this3.handleFieldChange(child.props.name)
          }));
        }
        return child;
      }),
          grouped = _reactChildrenUtilities2.default.groupByType(formChildren, ['footer'], 'body');

      return _react2.default.createElement(
        'form',
        { onReset: this.handleReset, onSubmit: this.handleSubmit },
        grouped.body,
        grouped.footer && _react2.default.createElement(
          'div',
          { className: 'form-footer' },
          grouped.footer
        )
      );
    }
  }]);

  return Form;
}(_react.Component);

exports.default = Form;


Form.propTypes = {
  children: _propTypes2.default.node,
  onReset: _propTypes2.default.func,
  onSubmit: _propTypes2.default.func
};